
Imports System
Imports System.Data
Imports System.Drawing
Imports System.Web
Imports System.Web.UI.WebControls
Imports System.Web.UI.HtmlControls
Imports System.IO
Imports Telerik.WebControls



'/ <summary>
'/		Summary description for tree.
'/ </summary>

MustInherit Public Class ClientLoadOnDemandDirectory
   Inherits System.Web.UI.UserControl
   Protected message As System.Web.UI.WebControls.Label
   Protected WithEvents RadTree1 As RadTreeView
   Protected LoadingMessagePos As RadioButtonList
   
   
   Private Sub BindDirectory(dirPath As String, collection As RadTreeNodeCollection)
      Dim dirs As String() = Directory.GetDirectories(dirPath)
      Dim s As String
      For Each s In  dirs
         Dim parts As String() = s.Split("\"c)
         Dim name As String = parts((parts.Length - 1))
         Dim node As New RadTreeNode(name)
         node.Image = "Folder.gif"
         node.Value = s.Replace("\", "/")
         node.Category = "Folder"
         node.ExpandMode = ExpandMode.ServerSideCallBack
         collection.Add(node)
      Next s
      
      Dim files As String() = Directory.GetFiles(dirPath)
      Dim s As String
      For Each s In  files
         Dim parts As String() = s.Split("\"c)
         Dim name As String = parts((parts.Length - 1))
         Dim node As New RadTreeNode(name)
         Dim fi As New FileInfo(s)
         Select Case fi.Extension
            Case ".cs"
               node.Image = "cs.gif"
            Case ".css"
               node.Image = "css.gif"
            Case ".html"
               node.Image = "html.gif"
            Case ".resx"
               node.Image = "resx.gif"
            Case ".vb"
               node.Image = "vb.gif"
            Case ".xml"
               node.Image = "xml.gif"
            Case ".ascx"
               node.Image = "ascx.gif"
            Case ".gif", ".jpg"
               node.Image = "gif.gif"
            Case Else
               node.Image = "File.gif"
         End Select
         node.Value = fi.Name + "@" + fi.Length + "@" + fi.LastWriteTime.ToString()
         node.Category = "File"
         collection.Add(node)
      Next s
   End Sub 'BindDirectory
   
   
   Private Sub Page_Load(sender As Object, e As System.EventArgs) Handles MyBase.Load
      If Not Page.IsPostBack Then
         Dim rootFolder As String = Server.MapPath("./Examples")
         
         Dim rootNode As New RadTreeNode(rootFolder)
         rootNode.Image = "Folder.gif"
         rootNode.Expanded = True
         rootNode.Category = "Folder"
         RadTree1.AddNode(rootNode)
         
         BindDirectory(rootFolder, rootNode.Nodes)
         
         RadTree1.LoadingMessagePosition = LoadingMessagePosition.BeforeNodeText
         RadTree1.LoadingMessageCssClass = "LoadingMessageBlue"
         RadTree1.LoadingMessage = "(loading ..)"
      End If
   End Sub 'Page_Load
   
   
   Private Sub RadTree1_NodeExpand(o As Object, e As Telerik.WebControls.RadTreeNodeEventArgs) Handles RadTree1.NodeExpand
      Dim folderNode As RadTreeNode = e.NodeClicked
      Dim path As String = folderNode.Value
      BindDirectory(path, folderNode.Nodes)
   End Sub 'RadTree1_NodeExpand
   
   
   Protected Sub LoadingMessagePositionChanged(sender As Object, e As System.EventArgs)
      Select Case LoadingMessagePos.SelectedItem.Value
         Case "Before"
            RadTree1.LoadingMessagePosition = LoadingMessagePosition.BeforeNodeText
            RadTree1.LoadingMessageCssClass = "LoadingMessageBlue"
            RadTree1.LoadingMessage = "(loading ..)"
         Case "After"
            RadTree1.LoadingMessagePosition = LoadingMessagePosition.AfterNodeText
            RadTree1.LoadingMessageCssClass = "LoadingMessageBlue"
            RadTree1.LoadingMessage = "(loading ...)"
         Case "Below"
            RadTree1.LoadingMessagePosition = LoadingMessagePosition.BelowNodeText
            RadTree1.LoadingMessageCssClass = "LoadingMessage"
            RadTree1.LoadingMessage = "(loading ...)"
         Case "None"
            RadTree1.LoadingMessagePosition = LoadingMessagePosition.None
      End Select
   End Sub 'LoadingMessagePositionChanged
   
   #Region "Web Form Designer generated code"
   
   Protected Overrides Sub OnInit(e As EventArgs)
      InitializeComponent()
      MyBase.OnInit(e)
   End Sub 'OnInit
   
   
   '/		Required method for Designer support - do not modify
   '/		the contents of this method with the code editor.
   '/ </summary>
   Private Sub InitializeComponent()
   End Sub 'InitializeComponent
   
   #End Region
End Class 'ClientLoadOnDemandDirectory 

