using System;
using System.Xml;
using System.Data;
using System.Drawing;
using System.Web;
using System.Data.OleDb;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using Telerik.WebControls;


namespace Tree.Examples.Design.Basic
{
	/// <summary>
	///		Summary description for tree.
	/// </summary>
	public abstract class ClientLoadOnDemand : System.Web.UI.UserControl
	{
		protected Telerik.WebControls.RadTreeView RadTree1;
		protected RadioButtonList LoadingMessagePos;

		private DataSet GetNodeData(string query)
		{
			OleDbConnection dbCon = new OleDbConnection ("Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" + Server.MapPath("Examples/Programming/ClientLoadOnDemandSql/Nodes.mdb")); 
			dbCon.Open();

			OleDbDataAdapter adapter = new OleDbDataAdapter(query, dbCon);
			DataSet ds = new DataSet();
			adapter.Fill(ds);
			dbCon.Close();

			return ds;
		}
		
		private void LoadRootNodes()
		{
			DataSet ds = GetNodeData("SELECT * FROM Nodes WHERE ParentId IS NULL");
			foreach (DataRow row in ds.Tables[0].Rows)
			{
				RadTreeNode node = new RadTreeNode();
				node.Text = (string) row["Text"];
				node.Value = ((int) row["Id"]).ToString();
				node.ID = ((int) row["Id"]).ToString();
				node.ExpandMode = ExpandMode.ServerSideCallBack;
				RadTree1.Nodes.Add(node);
			}
		}
		
		private void Page_Load(object sender, System.EventArgs e)
		{
			if (!Page.IsPostBack)
			{
				LoadRootNodes();

				RadTree1.LoadingMessagePosition = LoadingMessagePosition.BeforeNodeText; 
				RadTree1.LoadingMessageCssClass = "LoadingMessageBlue";
				RadTree1.LoadingMessage = "(loading ..)";
			}
		}

		private void RadTree1_NodeExpand(object o, Telerik.WebControls.RadTreeNodeEventArgs e)
		{
			string sql = @"SELECT
							Nodes.Id AS NodeId, Nodes.Text AS NodeText, COUNT(Children.Id) AS HasChildren
						FROM 
							Nodes
						LEFT JOIN
							Nodes Children
						ON
							Nodes.Id = Children.ParentId
						WHERE
							Nodes.ParentId = {0}
						GROUP BY
							Nodes.Id, Nodes.Text
						";

			sql = String.Format(sql, e.NodeClicked.ID);
			DataSet ds = GetNodeData(sql);
			
			foreach (DataRow row in ds.Tables[0].Rows)
			{
				RadTreeNode node = new RadTreeNode();
				node.Text = (string) row["NodeText"];
				node.ID = ((int) row["NodeId"]).ToString();
				node.Image = "1.gif";
				node.Target = "_new";
				if ( ((int) row["HasChildren"]) > 0)
					node.ExpandMode = ExpandMode.ServerSideCallBack;
				e.NodeClicked.Nodes.Add(node);				
			}			
		}

		protected void LoadingMessagePositionChanged(object sender, System.EventArgs e) 
		{
			switch (LoadingMessagePos.SelectedItem.Value)
			{
				case "Before" : 
					RadTree1.LoadingMessagePosition = LoadingMessagePosition.BeforeNodeText; 
					RadTree1.LoadingMessageCssClass = "LoadingMessageBlue";
					RadTree1.LoadingMessage = "(loading ..)";
					break;
				case "After" :	
					RadTree1.LoadingMessagePosition = LoadingMessagePosition.AfterNodeText;
					RadTree1.LoadingMessageCssClass = "LoadingMessageBlue";
					RadTree1.LoadingMessage = "(loading ...)";
					break;
				case "Below" :	
					RadTree1.LoadingMessagePosition = LoadingMessagePosition.BelowNodeText; 
					RadTree1.LoadingMessageCssClass = "LoadingMessage";
					RadTree1.LoadingMessage = "(loading ...)";
					break;
				case "None" :	
					RadTree1.LoadingMessagePosition = LoadingMessagePosition.None; 
					break;
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			InitializeComponent();
			base.OnInit(e);
		}
		
		///		Required method for Designer support - do not modify
		///		the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{			
			this.RadTree1.NodeExpand += new Telerik.WebControls.RadTreeView.RadTreeViewEventHandler(this.RadTree1_NodeExpand);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		

	}
}
