using System;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.IO;
using Telerik.WebControls;

namespace Tree.Examples.Programming.DirectoryStructure
{
	/// <summary>
	///		Summary description for tree.
	/// </summary>
	public abstract class tree : System.Web.UI.UserControl
	{
		protected Telerik.WebControls.RadTreeView RadTree1;
		
		private void BindTreeToDirectory(string dirPath, RadTreeNode parentNode)
		{
			string[] dirs = Directory.GetDirectories(dirPath);
			foreach (string s in dirs)
			{
				string[] parts = s.Split('\\');
				string name = parts[parts.Length-1];
				RadTreeNode node = new RadTreeNode(name);
				node.Image = "Folder.gif";
				node.Value = name;
				node.Category = "Folder";
				parentNode.AddNode(node);

				BindTreeToDirectory(s, node);
			}

			string[] files = Directory.GetFiles(dirPath);
			foreach (string s in files)
			{
				string[] parts = s.Split('\\');
				string name = parts[parts.Length-1];
				RadTreeNode node = new RadTreeNode(name);				
				FileInfo fi = new FileInfo(s);
				node.Image = "File.gif";
				node.Value = fi.Name + "@" + fi.Length + "@" + fi.LastWriteTime.ToString();				
				node.Category = "File";
				parentNode.AddNode(node);
			}			
		}
		
		protected void Page_Load(object sender, EventArgs e)
		{		
			if (!Page.IsPostBack)
			{
				string rootFolder = Server.MapPath("./Examples");
		
				RadTreeNode rootNode = new RadTreeNode(rootFolder);
				rootNode.Image = "Folder.gif";
				RadTree1.AddNode(rootNode);

				BindTreeToDirectory(rootFolder, rootNode);			
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		///		Required method for Designer support - do not modify
		///		the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{			
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

	}
}
