using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using Telerik.WebControls;
using System.IO;

namespace sample
{
	/// <summary>
	//the code snippets which are commented are for the first workaround
	//!!please consult with the respective KB to make the appropriate corrections
	/// </summary>
	public class WebForm1 : System.Web.UI.Page
	{
	
		protected Telerik.WebControls.RadTreeView RadTree1;
		protected bool flag = false;

		/*private bool CheckForChildren(string s)
		{
			string [] dirs = Directory.GetDirectories(s);
			string [] files = Directory.GetFiles(s);
			if(dirs.Length > 0 || files.Length > 0)
				return true;
			else
				return false;
		}*/
		private void BindDirectory(string dirPath, RadTreeNodeCollection collection)
		{              
			string[] dirs = Directory.GetDirectories(dirPath);
			string[] files = Directory.GetFiles(dirPath);

			if(!flag || dirs.Length > 0 || files.Length > 0)
			{
				foreach (string s in dirs)
				{
                    //bool flag = CheckForChildren(s);
					string[] parts = s.Split('\\');
					string name = parts[parts.Length-1];
					RadTreeNode node = new RadTreeNode(name);
					node.Image = "Folder.gif";
					node.Value = s.Replace(@"\",@"/");
					node.Category = "Folder";
					//if(flag)
					//	node.ExpandMode = ExpandMode.ServerSideCallBack;
					node.ExpandMode = ExpandMode.ServerSideCallBack;
					collection.Add(node);
				}
			}
			else
			{
				RadTreeNode disabled = new RadTreeNode("no children");
				disabled.Enabled = false;
				collection.Add(disabled);	    
			}

			
			foreach (string s in files)
			{
				string[] parts = s.Split('\\');
				string name = parts[parts.Length-1];
				RadTreeNode node = new RadTreeNode(name);
				FileInfo fi = new FileInfo(s);
				switch (fi.Extension)
				{
					case ".cs" : node.Image = "cs.gif"; break;
					case ".css" : node.Image = "css.gif"; break;
					case ".html" : node.Image = "html.gif"; break;
					case ".resx" : node.Image = "resx.gif"; break;
					case ".vb" : node.Image = "vb.gif"; break;
					case ".xml" : node.Image = "xml.gif"; break;
					case ".ascx" : node.Image = "ascx.gif"; break;
					case ".gif" : 
					case ".jpg" : node.Image = "gif.gif"; break;
					default: node.Image = "File.gif"; break;
				}                        
				node.Value = fi.Name + "@" + fi.Length + "@" + fi.LastWriteTime.ToString();
				node.Category = "File";
				collection.Add(node);
			}
		}
            
		private void Page_Load(object sender, System.EventArgs e)
		{
			if (!Page.IsPostBack)
			{
				string rootFolder = Server.MapPath("Examples");

				RadTreeNode rootNode = new RadTreeNode(rootFolder);
				rootNode.Image = "Folder.gif";
				rootNode.Expanded = true;
				rootNode.Category = "Folder";
				RadTree1.AddNode(rootNode);

				BindDirectory(rootFolder, rootNode.Nodes);      

			}
		}

		private void RadTree1_NodeExpand(object o, Telerik.WebControls.RadTreeNodeEventArgs e)
		{
			RadTreeNode folderNode = e.NodeClicked;      
			string path = folderNode.Value;
			flag = true;
			BindDirectory(path, folderNode.Nodes);
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.RadTree1.NodeExpand+= new Telerik.WebControls.RadTreeView.RadTreeViewEventHandler(RadTree1_NodeExpand);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

        



	}
}
